Attribute VB_Name = "StrDiff"
Option Explicit

Private nCntSrc1  As Long
Private nCntSrc2  As Long
Private sSrc1()   As String
Private sSrc2()   As String

Private nSumB1()  As Long ' 16Bit ̕]l
Private nSumB2()  As Long
Private nSumB1Xor() As Long ' 16Bitl̗ݐ xor l
Private nSumB2Xor() As Long

Private nSum1First(65535) As Long '̒lŏ nSum ւ̃|C^
Private nSum2First(65535) As Long
Private nSum1Last(65535) As Long  '̒lŌ nSum ւ̃|C^
Private nSum2Last(65535) As Long
Private nSum1NextPtr() As Long  'l nSum ւ̃|C^
Private nSum2NextPtr() As Long


Private nCntCom     As Long
Private nComFlg()   As Long   ' 0-Equ   1-Not Equal
Private nComPtr1()  As Long
Private nComPtr2()  As Long
Private nComLen1()  As Long
Private nComLen2()  As Long
Private nComNext()  As Long   ' -1-End, Others Next ComPtr

Private nReadPtr    As Long
Private nReadLine1  As Long
Private nReadLine2  As Long
Private bReadDual   As Boolean
Private bReadEOF    As Boolean

'eLXgŜAsŕ̂PsԂ
Private Function GetNextLine(ByRef BaseStr As String, ByRef ptr As Long) As String
    Dim nPtr As Long
    Dim sStr As String
    Dim sRightChr As String
    Dim nVal As Long

    If ptr = -1 Then
        GetNextLine = ""
        Exit Function
    End If

    nPtr = InStr(ptr, BaseStr, vbLf)
    If nPtr = 0 Then
        sStr = Mid$(BaseStr, ptr)
        ptr = -1
    Else
        sStr = Mid$(BaseStr, ptr, nPtr - ptr)
        ptr = nPtr + 1
    End If

    sRightChr = Right$(sStr, 1)
    If sRightChr = vbCr Or sRightChr = Chr$(&H1A) Then
        GetNextLine = Mid$(sStr, 1, Len(sStr) - 1)
    Else
        GetNextLine = sStr
    End If

End Function

'Ps̕ɂāA`FbNTlZoĕԂ
Private Sub GetChkSumVal(ByRef sStr As String, ByRef lChkSum16 As Long)
  Dim nChkSum As Long
  Dim sChr() As Byte
  Dim i As Long
  Dim nWrk1 As Long
  Dim nWrk2 As Long

  sChr = sStr
  nChkSum = 0
  For i = LBound(sChr) To UBound(sChr)
    ' O̕܂ł̃`FbNT15bitō[e[gAPxor F{͂PUłǂAÔ߂PTɂ
    nWrk2 = (nChkSum >= 16384) And 1                  ' PTڂ̂OPAOڂɎĂinWrk2͂OPɂȂj
    nWrk1 = (nChkSum And 16383)                       ' PS܂ł擾iɂQ{ɂ̂ŁAPSɉBPTɂȂ
    nChkSum = ((nWrk1 + nWrk1 + nWrk2) Xor sChr(i))   ' nWrk1 Q񑫂Ăۂ͂Q{ĂBnWrk2Z邱ƂŁAʂʂփ[e[gł
    
    'nChkSum = ((nChkSum * 2) Xor sChr(i)) And &H7FFF
    ' ]̂Q{ł́AP邲ƂɁA܂ł̐lǂǂʂփVtgE񂪌Ă
    ' ̂߁AŌ݂̐̂LɂȂ邱ƂɂȂ
    ' [e[g邱ƂŁAs̍ŏɂď񂪌邱ƂBAPɕP
    ' OɓւĂP[XłA`FbNT͕ʂ̒lɂȂ\ȂBEEȄŖʂȔrȂ\
  Next

  lChkSum16 = nChkSum
End Sub

'eLXgt@CsɕAA`FbNTZoĔzɎ߂
Private Sub GetSrc(ByRef sVal As String, ByRef nCnt As Long, _
                   ByRef sSrc() As String, ByRef nSumB() As Long, _
                   ByRef nSumBXor() As Long, _
                   ByRef nSumFirst() As Long, ByRef nSumLast() As Long, ByRef nSumNextPtr() As Long)

  Dim nPtr As Long
  Dim sLine As String
  Dim nChkSum16 As Long
  Dim nChkSum8 As Long
  Dim nXor  As Long
  Dim i As Long
  Dim nIdx As Long


  nCnt = 0
  ReDim sSrc(0)
  ReDim nSumB(0)
  ReDim nSumBXor(0)
  ReDim nSumNextPtr(0)

  'CfbNXp̔zNA
  For i = 0 To 65535
    nSumFirst(i) = 0
    nSumLast(i) = 0
  Next

  'ώZwnq̏l͂O
  nXor = 0
  nSumBXor(0) = nXor

  'Ps̏
  nPtr = 1
  If sVal = "" Then nPtr = 1
  Do
    If nPtr = -1 Then Exit Do
    'Psǂݍ
    sLine = GetNextLine(sVal, nPtr)
  
    'E`FbNTEώZ̃GANA
    nCnt = nCnt + 1
    ReDim Preserve sSrc(nCnt)
    ReDim Preserve nSumB(nCnt)
    ReDim Preserve nSumBXor(nCnt)
    ReDim Preserve nSumNextPtr(nCnt)

    'PsɂāA`FbNT̎Zo
    Call GetChkSumVal(sLine, nChkSum16)
    'ώZl̎Zo
    nXor = nXor Xor nChkSum16
    
    sSrc(nCnt) = sLine
    nSumB(nCnt) = nChkSum16
    nSumBXor(nCnt) = nXor
    nSumNextPtr(nCnt) = 0

    nIdx = nSumLast(nChkSum16)
    If nIdx = 0 Then
      nSumFirst(nChkSum16) = nCnt
      nSumLast(nChkSum16) = nCnt
    Else
      nSumLast(nChkSum16) = nCnt
      nSumNextPtr(nIdx) = nCnt
    End If

  Loop

End Sub

'eLXgt@CPsɕAA`FbNTZoĔzɎ߂
Public Sub CompareSrc1(ByRef sVal As String)
  Call GetSrc(sVal, nCntSrc1, sSrc1(), nSumB1(), nSumB1Xor(), nSum1First(), nSum1Last(), nSum1NextPtr())
End Sub

'eLXgt@CQsɕAA`FbNTZoĔzɎ߂
Public Sub CompareSrc2(ByRef sVal As String)
  Call GetSrc(sVal, nCntSrc2, sSrc2(), nSumB2(), nSumB2Xor(), nSum2First(), nSum2Last(), nSum2NextPtr())
End Sub

'^vFƂɑSĂL̏ԂƂAt@CŜA̍Ώۂ͈̔͂ɂ
Private Sub InitComp()
  nCntCom = 1
  ReDim nComFlg(nCntCom)
  ReDim nComPtr1(nCntCom)
  ReDim nComPtr2(nCntCom)
  ReDim nComLen1(nCntCom)
  ReDim nComLen2(nCntCom)
  ReDim nComNext(nCntCom)

  nComFlg(nCntCom) = 1
  If nCntSrc1 = 0 Then
    nComPtr1(nCntCom) = 0
    nComLen1(nCntCom) = 0
  Else
    nComPtr1(nCntCom) = 1
    nComLen1(nCntCom) = nCntSrc1
  End If
  If nCntSrc2 = 0 Then
    nComPtr2(nCntCom) = 0
    nComLen2(nCntCom) = 0
  Else
    nComPtr2(nCntCom) = 1
    nComLen2(nCntCom) = nCntSrc2
  End If
  nComNext(nCntCom) = -1

End Sub

'Q̃eLXg̔rFCW[
Public Sub CompareStr()
  Dim bChange As Boolean
  Dim nPtr As Long

  'FSĂ̍sLɃ}[N
  Call InitComp
  nPtr = 1
  bChange = True

  's
  '  Ƃ͈͂̒Ałv͈͂o
  '    oȂiPsv̂jꍇAhw͈͂̑ŜhƂAɌ͈̂͂
  '    oꍇAv͈͂}[NB܂Av̑OオsvӏɂȂB
  '    @ʂƂāAP̕svӏAP̈vӏƁAÔQ̕svӏɕBEEEvӏPłƂɒ
  '    @svӏɂāAlɏJԂāAvӏ𑝂₵ĂB
  Do
    If bChange = False Then
      nPtr = nComNext(nPtr)
      If nPtr = -1 Then
        Exit Do
      End If
    End If
    Call ExecCompare(nPtr, bChange)
  Loop

End Sub

'̍sv邩irΏƂ̕śAꂼsԍŎw肳j
Private Function CompareLine(nPtr1 As Long, nPtr2 As Long) As Boolean
  If nPtr1 > nCntSrc1 Or nPtr2 > nCntSrc2 Then
    'ǂݍ񂾕̍s𒴂ĂFقȂƔf
    CompareLine = False
  ElseIf nSumB1(nPtr1) <> nSumB2(nPtr2) Then
    '`FbNTvȂFrȂĂAقȂƔfł
    CompareLine = False
  ElseIf sSrc1(nPtr1) <> sSrc2(nPtr2) Then
    '`FbNTvAۂ̕񂪈قȂĂ
    CompareLine = False
  Else
    '͈v
    CompareLine = True
  End If
  
End Function

'rʂ̊i[zɁA^vo
Private Sub SetCompare(ByRef bChange As Boolean, ByRef bAdd As Boolean, ByRef nComPtr As Long, ByRef nFlg As Long, ByRef nPtr1 As Long, ByRef nPtr2 As Long, ByRef nLen1 As Long, ByRef nLen2 As Long)

  If bAdd Then
    'Qڈȍ~́A^v̏o͐z񎩐gǉ
    bChange = True
    nCntCom = nCntCom + 1
    ReDim Preserve nComFlg(nCntCom)
    ReDim Preserve nComPtr1(nCntCom)
    ReDim Preserve nComPtr2(nCntCom)
    ReDim Preserve nComLen1(nCntCom)
    ReDim Preserve nComLen2(nCntCom)
    ReDim Preserve nComNext(nCntCom)
    
    nComNext(nCntCom) = nComNext(nComPtr)   '^v񂪘A悤AeLXg̏ɏ]āA̔zCfbNXێ
    nComNext(nComPtr) = nCntCom
    nComPtr = nCntCom

  Else
    'Pڂ́AƂƂ́iƂ錳ɂȂj^v㏑čėp
    bAdd = True
  End If

  nComFlg(nComPtr) = nFlg
  nComPtr1(nComPtr) = nPtr1
  nComPtr2(nComPtr) = nPtr2
  nComLen1(nComPtr) = nLen1
  nComLen2(nComPtr) = nLen2

End Sub

'svƂꂽ͈͂ɂāAvӏT
Private Sub ExecCompare(ByRef nPComPtr As Long, ByRef bChange As Boolean)
  Dim bAdd      As Boolean
  Dim nComPtr   As Long
  
  Dim nReadPtr1 As Long
  Dim nReadPtr2 As Long

  Dim nReadMax1 As Long
  Dim nReadMax2 As Long
  Dim nReadMin1 As Long
  Dim nReadMin2 As Long
  Dim nReadLen1 As Long
  Dim nReadLen2 As Long

  Dim nPhase    As Long

  Dim bReaded     As Boolean
  Dim nBufStart1  As Long
  Dim nBufStart2  As Long
  Dim nBufFlg     As Long

  Dim bFind As Boolean
  Dim nFindPtr1 As Long
  Dim nFindPtr2 As Long
  Dim nFindLen  As Long


  '
  bChange = False
  nComPtr = nPComPtr
  
  '͈͓vĂꍇ́AΏۊO
  If nComFlg(nComPtr) = 0 Then
    Exit Sub
  End If
  
  ' ͈͂
  nReadMin1 = nComPtr1(nComPtr)
  nReadMin2 = nComPtr2(nComPtr)
  nReadLen1 = nComLen1(nComPtr)
  nReadLen2 = nComLen2(nComPtr)
  nReadMax1 = nReadMin1 + nReadLen1
  nReadMax2 = nReadMin2 + nReadLen2
  nReadPtr1 = nReadMin1
  nReadPtr2 = nReadMin2

  'Ȃꍇ́AΏۊO
  If nReadLen1 = 0 Or nReadLen2 = 0 Then
    Exit Sub
  End If

  nPhase = 0
  bAdd = False
  bReaded = False
  bChange = False
  
  Do
    If nReadPtr1 >= nReadMax1 And nReadPtr2 >= nReadMax2 Then
      Exit Do
    End If
  
    'ȂƂI
    If nReadPtr1 >= nReadMax1 Or nReadPtr2 >= nReadMax2 Then
      'c̑SĂsvӏƂďo
      Call SetCompare(bChange, bAdd, nComPtr, 1, nReadPtr1, nReadPtr2, nReadMax1 - nReadPtr1, nReadMax2 - nReadPtr2)
      nReadPtr1 = nReadMax1
      nReadPtr2 = nReadMax2
      Exit Do
    End If
  
    'svӏT
    If nPhase = 0 Then
      Do
        If nReadPtr1 >= nReadMax1 Or nReadPtr2 >= nReadMax2 Then
          'Ⴂ𔭌EEEI
          nPhase = 2
          Exit Do
        ElseIf CompareLine(nReadPtr1, nReadPtr2) = False Then
          'Ⴂ𔭌
          nPhase = 1
          Exit Do
        Else
          If Not bReaded Then
            bReaded = True
            nBufFlg = 0
            nBufStart1 = nReadPtr1
            nBufStart2 = nReadPtr2
          End If
          nReadPtr1 = nReadPtr1 + 1
          nReadPtr2 = nReadPtr2 + 1
        End If
      Loop
      If bReaded Then
        Call SetCompare(bChange, bAdd, nComPtr, nBufFlg, nBufStart1, nBufStart2, nReadPtr1 - nBufStart1, nReadPtr2 - nBufStart2)
        bReaded = False
      End If

    End If
    
    'Ⴂ𔭌
    If nPhase = 1 Then
      '̈vӏ
      Call SearchMatch(nReadPtr1, nReadPtr2, nReadMax1, nReadMax2, bFind, nFindPtr1, nFindPtr2, nFindLen)
      If bFind Then
        '̈vӏ܂ło
        Call SetCompare(bChange, bAdd, nComPtr, 1, nReadPtr1, nReadPtr2, nFindPtr1 - nReadPtr1, nFindPtr2 - nReadPtr2)
        'vӏo
        Call SetCompare(bChange, bAdd, nComPtr, 0, nFindPtr1, nFindPtr2, nFindLen, nFindLen)
        'ɒTsvӏI
        nReadPtr1 = nFindPtr1 + nFindLen
        nReadPtr2 = nFindPtr2 + nFindLen
      Else
        'c̑SĂsvӏƂďo
        Call SetCompare(bChange, bAdd, nComPtr, 1, nReadPtr1, nReadPtr2, nReadMax1 - nReadPtr1, nReadMax2 - nReadPtr2)
        nReadPtr1 = nReadMax1
        nReadPtr2 = nReadMax2
      End If
    End If
 
  Loop

End Sub

'vsTiłvsD悷j
Private Sub SearchMatch(ByRef nStPtr1 As Long, ByRef nStPtr2 As Long, ByRef nMax1 As Long, ByRef nMax2 As Long, _
                        ByRef bOFind As Boolean, ByRef nOFindPtr1 As Long, ByRef nOFindPtr2 As Long, ByRef nOFindLen As Long)
  Dim nAdd As Long
  Dim bFind As Boolean
  Dim nFindDist As Long
  Dim nFindPtr1 As Long
  Dim nFindPtr2 As Long
  Dim nFindLen  As Long

  Dim nXor1 As Long
  Dim nXor2 As Long

  Dim i As Long
  Dim nPtr1 As Long
  Dim nPtr2 As Long

  Dim nIdxPtr As Long

  Dim nChkLen As Long
  Dim nChkPtr1 As Long
  Dim nChkPtr2 As Long
  Dim nChkDist As Long

  nPtr1 = nStPtr1
  bFind = False
  nFindPtr1 = nStPtr1
  nFindPtr2 = nStPtr2
  nFindLen = 1
  Do
    If nPtr1 + (nFindLen - 1) >= nMax1 Then
      Exit Do
    End If

    nXor1 = nSumB1Xor(nPtr1 - 1) Xor nSumB1Xor(nPtr1 + nFindLen - 1)
    nIdxPtr = nSum2First(nSumB1(nPtr1))

    Do
      If nIdxPtr = 0 Then Exit Do
      If nIdxPtr + (nFindLen - 1) >= nMax2 Then Exit Do

      If nIdxPtr >= nStPtr2 Then

        nPtr2 = nIdxPtr
        nXor2 = nSumB2Xor(nPtr2 - 1) Xor nSumB2Xor(nPtr2 + nFindLen - 1)
  
        If nXor1 = nXor2 Then
          'v\̂ŁAsmF
          nChkLen = 0
          nChkPtr1 = nPtr1
          nChkPtr2 = nPtr2
          Do
            If nChkPtr1 >= nMax1 Or nChkPtr2 >= nMax2 Then
              Exit Do
            End If
            If CompareLine(nChkPtr1, nChkPtr2) Then
              nChkLen = nChkLen + 1
              nChkPtr1 = nChkPtr1 + 1
              nChkPtr2 = nChkPtr2 + 1
            Else
              Exit Do
            End If
          Loop
          'vsr
          nChkDist = (nPtr1 - nStPtr1) + (nPtr2 - nStPtr2)
          If bFind Then
            If nFindLen = nChkLen Then
              '̈vӏQӏꍇ́A̐擪s߂ق̗pBivӏ̍sԍ | ̐擪sԍj
              If nChkDist < nFindDist Then
                nFindDist = nChkDist
                nFindPtr1 = nPtr1
                nFindPtr2 = nPtr2
                nFindLen = nChkLen
                nXor1 = nSumB1Xor(nPtr1 - 1) Xor nSumB1Xor(nPtr1 + nFindLen - 1)
              End If
            ElseIf nFindLen < nChkLen Then
              nFindDist = nChkDist
              nFindPtr1 = nPtr1
              nFindPtr2 = nPtr2
              nFindLen = nChkLen
              nXor1 = nSumB1Xor(nPtr1 - 1) Xor nSumB1Xor(nPtr1 + nFindLen - 1)
            End If
          ElseIf nChkLen <> 0 Then
            bFind = True
            nFindDist = nChkDist
            nFindPtr1 = nPtr1
            nFindPtr2 = nPtr2
            nFindLen = nChkLen
            nXor1 = nSumB1Xor(nPtr1 - 1) Xor nSumB1Xor(nPtr1 + nFindLen - 1)
          End If
          
        End If

      End If

      nIdxPtr = nSum2NextPtr(nIdxPtr)
    Loop

    nPtr1 = nPtr1 + 1
  Loop

  bOFind = bFind
  nOFindPtr1 = nFindPtr1
  nOFindPtr2 = nFindPtr2
  nOFindLen = nFindLen

End Sub

Private Sub ReadInit()
  nReadPtr = 1
  nReadLine1 = 1
  nReadLine2 = 1
  bReadEOF = False
End Sub

Public Sub ReadInitDual()
  Call ReadInit
  bReadDual = True
End Sub

Public Sub ReadInitSingle()
  Call ReadInit
  bReadDual = False
End Sub

Public Sub ReadLine(ByRef sStr1 As String, ByRef sStr2 As String, ByRef nSrcLine1 As Long, ByRef nSrcLine2 As Long, ByRef nFlg As Long)
  Dim bRead1 As Boolean
  Dim bRead2 As Boolean
  
  sStr1 = ""
  sStr2 = ""
  nFlg = -1
  
  If nCntCom < nReadPtr Or bReadEOF Then
    bReadEOF = True
    Exit Sub
  End If

  If nComLen1(nReadPtr) < nReadLine1 And nComLen2(nReadPtr) < nReadLine2 Then
    If nComNext(nReadPtr) = -1 Then
      bReadEOF = True
      Exit Sub
    End If
    
    nReadPtr = nComNext(nReadPtr)
    nReadLine1 = 1
    nReadLine2 = 1
    Call ReadLine(sStr1, sStr2, nSrcLine1, nSrcLine2, nFlg)
    Exit Sub
  End If

  bRead1 = False
  bRead2 = False
  nSrcLine1 = 0
  nSrcLine2 = 0
  'PZbg
  If nComLen1(nReadPtr) >= nReadLine1 Then
    bRead1 = True
    nSrcLine1 = nComPtr1(nReadPtr) + nReadLine1 - 1
    sStr1 = sSrc1(nSrcLine1)
    nReadLine1 = nReadLine1 + 1
  End If
  'QZbg
  If nComLen2(nReadPtr) >= nReadLine2 And ((bReadDual = True) Or (bRead1 = False) Or nComFlg(nReadPtr) = 0) Then
    bRead2 = True
    nSrcLine2 = nComPtr2(nReadPtr) + nReadLine2 - 1
    sStr2 = sSrc2(nSrcLine2)
    nReadLine2 = nReadLine2 + 1
  End If
  If nComFlg(nReadPtr) = 0 Then
    nFlg = 0
  ElseIf bRead1 And bRead2 Then
    nFlg = 3
  ElseIf bRead1 Then
    nFlg = 1
  Else
    nFlg = 2
  End If

End Sub

Public Function ReadEOF() As Boolean
  ReadEOF = bReadEOF
End Function

